"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _helperPluginUtils = require("@babel/helper-plugin-utils");
var _visitorProgramExit = require("./visitor-program-exit");
var _provider = require("./helpers/provider");
var process = _interopRequireWildcard(require("node:process"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
//TODO 得考虑，是否要加map post到服务器，降低接入成本。对应的map接口需要可以更新
var _default = exports.default = (0, _helperPluginUtils.declare)((api, config, dirname) => {
  api.assertVersion(7);
  return {
    visitor: {
      Program: {
        exit: path => {
          if (process.env.NODE_ENV !== 'production') {
            return;
          }
          // 侦测流水线
          // 优先级：手动设置 > CI/CD提供商
          // hit需要打到__coverage__中，因为ui自动化测试工具部署地方不确定
          // map就不需要，写到本地时，可以侦测本地流水线变量，直接上报上来
          // 他的职责只是寻找到项目，和插桩路径
          const serviceParams = (0, _provider.detectProvider)({
            envs: process.env,
            // @ts-ignore
            args: {
              projectID: config.projectID,
              sha: config.sha,
              // instrumentCwd: config.instrumentCwd,
              branch: config.branch
            }
          });
          // console.log(serviceParams,'serviceParams')
          (0, _visitorProgramExit.visitorProgramExit)(api, path, {
            projectID: config.projectID || serviceParams.slug || '-',
            sha: config.sha || serviceParams.commit || '-',
            instrumentCwd: config.instrumentCwd || process.cwd(),
            dsn: config.dsn || process.env['DSN'] || 'http://localhost:3000'
          });
        }
      }
    }
  };
});